various fixes and improvements
[automated-distro-installer] / fai-redep
index 4ca3ea52b628df6fed6b6f86ae3151bc1fbd4995..97302608703b55acb479795740e663e12e3a79de 100755 (executable)
--- a/fai-redep
+++ b/fai-redep
@@ -5,12 +5,19 @@ set -x
 # then start a virtual machine to test the config.
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 cd $(dirname $(readlink -f "$BASH_SOURCE"))
 
-ssh root@faiserver rm -rf /srv/fai/config
-scp -r fai/config root@faiserver:/srv/fai
+
+# i use faiserver as a dns alias, but ssh key is associated with
+# a canonical hostname and we will have ssh warning spam unless we
+# use it, so look it up.
+faiserver_host=$(chost faiserver) || faiserver_host=faiserver
+
+
+ssh root@$faiserver_host rm -rf /srv/fai/config
+scp -r fai/config root@$faiserver_host:/srv/fai
 # fai example pass: fai
 #ROOTPW='$1$kBnWcO.E$djxB128U7dMkrltJHPf6d1'
 
@@ -20,21 +27,27 @@ scp -r fai/config root@faiserver:/srv/fai
 # On arch, best seems to be copy your shadow file to a temp location,
 # then passwd, get out the new pass, then copy the shadow file back.
 
-if [[ -e /q/root/shadow/standard ]]; then
-    # note, it would be best to have some kind of security on this file
-    ssh root@faiserver tee -a /srv/fai/config/class/DEFAULT.var <<EOF
-ROOTPW='$(cat /q/root/shadow/standard)'
+f=/q/root/shadow/standard
+if s test -e $f; then
+    ssh root@$faiserver_host tee -a /srv/fai/config/class/DEFAULT.var <<EOF
+ROOTPW='$(s cat $f)'
 EOF
 fi
 
 tpvar="$(s cat /q/root/shadow/traci-simple)"
-ssh root@faiserver tee -a /srv/fai/config/class/tp.var <<EOF
+ssh root@$faiserver_host tee -a /srv/fai/config/class/tp.var <<EOF
 ROOTPW='$tpvar'
 EOF
 
 scp ~/.ssh/id_rsa.pub \
-    root@faiserver:/srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
+    root@$faiserver_host:/srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
+# todo: automatically disable faiserver after a period so
+# these files are not exposed.
 s scp -r /q/root/luks /q/root/shadow/traci{,-simple} \
-  root@faiserver:/srv/fai/config/distro-install-common
-scp /a/bin/devbyid root@faiserver:/srv/fai/nfsroot/usr/local/bin
-ssh root@faiserver chmod -R a+rX /srv/fai/config/distro-install-common
+  root@$faiserver_host:/srv/fai/config/distro-install-common
+scp /a/bin/devbyid root@$faiserver_host:/srv/fai/nfsroot/usr/local/bin
+ssh root@$faiserver_host bash <<'EOF'
+set -eE -o pipefail
+chmod 644 /srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
+chmod -R a+rX /srv/fai/config/distro-install-common
+EOF